Package org.xnio.conduits

# Class SynchronizedStreamSourceConduit

java.lang.Object
org.xnio.conduits.AbstractConduit<StreamSourceConduit>
org.xnio.conduits.AbstractSynchronizedConduit<StreamSourceConduit>
org.xnio.conduits.AbstractSynchronizedSourceConduit<StreamSourceConduit>
org.xnio.conduits.SynchronizedStreamSourceConduit

All Implemented Interfaces:
  `Conduit`, `SourceConduit`, `StreamSourceConduit`

public final class SynchronizedStreamSourceConduit extends AbstractSynchronizedSourceConduit<StreamSourceConduit> implements StreamSourceConduit
A synchronized stream source conduit. All conduit operations are wrapped in synchronization blocks for simplified thread safety.

Author:
  David M. Lloyd

## Field Summary

### Fields inherited from class org.xnio.conduits.AbstractSynchronizedConduit

`lock`

### Fields inherited from class org.xnio.conduits.AbstractConduit

`next`

## Constructor Summary

Constructors
Constructor
Description
`SynchronizedStreamSourceConduit(StreamSourceConduit next)`
Construct a new instance.
`SynchronizedStreamSourceConduit(StreamSourceConduit next, Object lock)`
Construct a new instance.

## Method Summary

Modifier and Type
Method
Description
`int`
`read(ByteBuffer dst)`
Read a sequence of bytes from this conduit to the given buffer.
`long`
`read(ByteBuffer[] dsts, int offs, int len)`
Read a sequence of bytes from this conduit to the given buffers.
`long`
`transferTo(long position, long count, FileChannel target)`
Transfers bytes into the given file from this channel.
`long`
`transferTo(long count, ByteBuffer throughBuffer, StreamSinkChannel target)`
Transfers bytes into the given channel target.

### Methods inherited from class org.xnio.conduits.AbstractSynchronizedSourceConduit

`awaitReadable, awaitReadable, getReadThread, isReadResumed, isReadShutdown, resumeReads, setReadReadyHandler, suspendReads, terminateReads, wakeupReads`

### Methods inherited from class org.xnio.conduits.AbstractConduit

`getWorker`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.xnio.conduits.Conduit

`getWorker`

### Methods inherited from interface org.xnio.conduits.SourceConduit

`awaitReadable, awaitReadable, getReadThread, isReadResumed, isReadShutdown, resumeReads, setReadReadyHandler, suspendReads, terminateReads, wakeupReads`

## Constructor Details

### SynchronizedStreamSourceConduit

public SynchronizedStreamSourceConduit(StreamSourceConduit next)
Construct a new instance. A new lock object is created.

Parameters:
  `next` - the next conduit in the chain

### SynchronizedStreamSourceConduit

public SynchronizedStreamSourceConduit(StreamSourceConduit next, Object lock)
Construct a new instance.

Parameters:
  `next` - the next conduit in the chain
  `lock` - the lock object to use

## Method Details

### transferTo

public long transferTo(long position, long count, FileChannel target) throws IOException
Description copied from interface: `StreamSourceConduit`
Transfers bytes into the given file from this channel.

Specified by:
  `transferTo` in interface `StreamSourceConduit`
Parameters:
  `position` - the position within the file from which the transfer is to begin
  `count` - the number of bytes to be transferred
  `target` - the file to write to
Returns:
  the number of bytes (possibly 0) that were actually transferred
Throws:
  `IOException` - if an I/O error occurs

### transferTo

public long transferTo(long count, ByteBuffer throughBuffer, StreamSinkChannel target) throws IOException
Description copied from interface: `StreamSourceConduit`
Transfers bytes into the given channel target. On entry, `throughBuffer` will be cleared. On exit, the buffer will be flipped for emptying, and may possibly be empty or may contain data. If this method returns a value less than `count`, then the remaining data in `throughBuffer` may contain data read from this channel which must be written to `target` to complete the operation.

Specified by:
  `transferTo` in interface `StreamSourceConduit`
Parameters:
  `count` - the number of bytes to be transferred
  `throughBuffer` - the buffer to copy through.
  `target` - the destination to write to
Returns:
  the number of bytes (possibly 0) that were actually transferred, or -1 if the end of input was reached
Throws:
  `IOException` - if an I/O error occurs

### read

public int read(ByteBuffer dst) throws IOException
Description copied from interface: `StreamSourceConduit`
Read a sequence of bytes from this conduit to the given buffer.

Specified by:
  `read` in interface `StreamSourceConduit`
Returns:
  the number of bytes (possibly 0) that were actually transferred, or -1 if the end of input was reached or this conduit's `SourceConduit.terminateReads()` method was previously called
Throws:
  `IOException` - if an error occurs

### read

public long read(ByteBuffer[] dsts, int offs, int len) throws IOException
Description copied from interface: `StreamSourceConduit`
Read a sequence of bytes from this conduit to the given buffers.

Specified by:
  `read` in interface `StreamSourceConduit`
Parameters:
  `offs` - the offset into the buffer array
  `len` - the number of buffers to fill
Returns:
  the number of bytes (possibly 0) that were actually transferred, or -1 if the end of input was reached or this conduit's `SourceConduit.terminateReads()` method was previously called
Throws:
  `IOException` - if an error occurs